searchNodes=[{"doc":"Extensible runtime configuration loader with pluggable providers","ref":"Hush.html","title":"Hush","type":"module"},{"doc":"","ref":"Hush.html#release_mode?/0","title":"Hush.release_mode?/0","type":"function"},{"doc":"","ref":"Hush.html#resolve!/0","title":"Hush.resolve!/0","type":"function"},{"doc":"","ref":"Hush.html#resolve!/1","title":"Hush.resolve!/1","type":"function"},{"doc":"This config provider can be attached to your release to run automatically on boot.","ref":"Hush.ConfigProvider.html","title":"Hush.ConfigProvider","type":"module"},{"doc":"Base implementation for a provider","ref":"Hush.Provider.html","title":"Hush.Provider","type":"behaviour"},{"doc":"","ref":"Hush.Provider.html#c:fetch/1","title":"Hush.Provider.fetch/1","type":"callback"},{"doc":"","ref":"Hush.Provider.html#is?/1","title":"Hush.Provider.is?/1","type":"function"},{"doc":"","ref":"Hush.Provider.html#c:load/1","title":"Hush.Provider.load/1","type":"callback"},{"doc":"Hush Provider to resolve Environmental Variables","ref":"Hush.Provider.SystemEnvironment.html","title":"Hush.Provider.SystemEnvironment","type":"module"},{"doc":"Callback implementation for Hush.Provider.fetch/1.","ref":"Hush.Provider.SystemEnvironment.html#fetch/1","title":"Hush.Provider.SystemEnvironment.fetch/1","type":"function"},{"doc":"Callback implementation for Hush.Provider.load/1.","ref":"Hush.Provider.SystemEnvironment.html#load/1","title":"Hush.Provider.SystemEnvironment.load/1","type":"function"},{"doc":"Replace configuration sugin provider-aware resolvers.","ref":"Hush.Resolver.html","title":"Hush.Resolver","type":"module"},{"doc":"","ref":"Hush.Resolver.html#resolve/1","title":"Hush.Resolver.resolve/1","type":"function"},{"doc":"","ref":"Hush.Resolver.html#resolve!/1","title":"Hush.Resolver.resolve!/1","type":"function"},{"doc":"Hush Hush makes it easy to configure your application at runtime and in release mode, it can retrieve configuration from multiple sources and is easily extensible.You'd use Hush as a configuration tuple, which gets replaced at runtime, this is useful to inject configuration that is not known at compile time.# config/prod.exs alias Hush.Provider.{GcpSecretManager,SystemEnvironment} config :your_app_name, Web.Endpoint, http: [port: {:hush, SystemEnvironment, &quot;PORT&quot;, [cast: :integer]}] secret_key_base: {:hush, GcpSecretManager, &quot;secret_key_base&quot;}Hush ships with a SystemEnvironment provider which reads environmental variables, but multiple providers exist to make your life easy in reading from other sources:ProviderDescriptionSystemEnvironmentRead environmental variablesGcpSecretManagerLoad secrets from Google Cloud Platform's Secret Manager.","ref":"readme.html","title":"Hush","type":"extras"},{"doc":"Add hush to your list of dependencies in mix.exs:def deps do [ {:hush, &quot;~&gt; 0.0.1&quot;} ] endRun mix deps.get to install it.","ref":"readme.html#installation","title":"Hush - Installation","type":"extras"},{"doc":"Some providers may need to initialize applications to function correctly. SystemEnvironment does not require any initialization and does not need to be in the list below.# config/config.exs config :hush, providers: [ GcpSecretsManager ]","ref":"readme.html#configuration","title":"Hush - Configuration","type":"extras"},{"doc":"Hush can be loaded by calling it directly, or by using its release Config.Provider.Loading via direct call# application.ex def start(_type, _args) do Hush.resolve!() endLoading via Config Provider# mix.exs def project do [ # ... releases: [ your_app_name: [ config_providers: [{Hush.ConfigProvider, nil}] ] ] ] endIf you are using Hush in both release and non-release mode, you still want to load it directly:# application.ex def start(_, _) do unless Hush.release_mode?(), do: Hush.resolve!() end","ref":"readme.html#resolving-runtime-configuration","title":"Hush - Resolving Runtime Configuration","type":"extras"},{"doc":"The configuration tuple is defined by a :hush atom, a provider module, a key for the provider and an optional list of options.{ :hush, provider :: module(), key :: String.t(), options :: [ default: any(), cast: :string | :integer | :float | :charlist | :atom ] }DefaultsBy default if a given key is not found by the provider, Hush will raise an error. To prevent this, provide a default in the options component of the tuple:# config/prod.exs alias Hush.Provider.SystemEnvironment config :your_app_name, Web.Endpoint, url: [host: {:hush, SystemEnvironment, &quot;HOST&quot;, [default: &quot;my-app.example&quot;]}]Casting# config/prod.exs alias Hush.Provider.SystemEnvironment config :your_app_name, Web.Endpoint, http: [port: {:hush, SystemEnvironment, &quot;PORT&quot;, [cast: :integer, default: 4000]}]","ref":"readme.html#usage","title":"Hush - Usage","type":"extras"},{"doc":"Hush is released under the Apache License 2.0 - see the LICENSE file.","ref":"readme.html#license","title":"Hush - License","type":"extras"}]